#
# spec file for package open-iscsi
#
# Copyright (c) 2011 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild


Name:           open-iscsi
BuildRequires:  bison db-devel flex
Url:            http://www.open-iscsi.org
License:        GPLv2+
Group:          Productivity/Networking/Other
PreReq:         %fillup_prereq %insserv_prereq
AutoReqProv:    on
Version:        2.0.870
Release:        37.38.1
Provides:       linux-iscsi
Obsoletes:      linux-iscsi
%define iscsi_release 865
Summary:        Linux* Open-iSCSI Software Initiator
Source:         %{name}-2.0-870-rc1.tar.bz2
Source11:       iscsi-gen-initiatorname.sh
Patch1:         %{name}-start-target-before-initiator
Patch2:         %{name}-suse-build-fixes
Patch3:         %{name}-fwparam_ppc-string-overflow
Patch4:         %{name}-update-init-script
Patch5:         %{name}-add-rhel5-compat
Patch6:         %{name}-add-sles10-compat
Patch7:         %{name}-iscsid-adjust-settings
Patch8:         %{name}-login-retry-update
Patch9:         %{name}-beta5-kernel-patch-update
Patch10:        %{name}-error-check-in-db-lock-creation
Patch11:        %{name}-initiator-compile-warning
Patch12:        %{name}-iscsi_discovery-doc-fixes
Patch13:        %{name}-rm-unused-variable
Patch14:        %{name}-add-error-msg-to-log.c
Patch15:        %{name}-sync-modules-with-2.6.27
Patch16:        %{name}-allow-onboot-for-loginall
Patch17:        %{name}-option-no-pid-file
Patch18:        %{name}-update-suse-init-scripts
Patch19:        %{name}-set-LOCK_DIR-during-compilation
Patch20:        %{name}-add-mkinitrd-scriptlets
Patch21:        %{name}-install-mkinitrd-scriptlets
Patch22:        %{name}-no-pid-file
Patch23:        %{name}-cxgb3i-support
Patch24:        %{name}-fw-crash-on-ppc
Patch25:        %{name}-fixup-onboot-for-loginall
Patch26:        %{name}-remove-dump-char
Patch27:        %{name}-load-ibft-before-reading-sys-firmware
Patch28:        %{name}-remove-trailing-tilde
Patch29:        open-iscsi-2.0-870-rc1-static.patch
Patch30:        open-iscsi-fix-sysfs-get-value-null
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
Open-iSCSI is a high-performance, transport independent, multi-platform
implementation of RFC3720 iSCSI.

Open-iSCSI is partitioned into user and kernel parts.

The kernel portion of Open-iSCSI is a from-scratch code licensed under
GPL. The kernel part implements iSCSI data path (that is, iSCSI Read
and iSCSI Write), and consists of two loadable modules: iscsi_if.ko and
iscsi_tcp.ko.

User space contains the entire control plane: configuration manager,
iSCSI Discovery, Login and Logout processing, connection-level error
processing, Nop-In and Nop-Out handling, and (in the future:) Text
processing, iSNS, SLP, Radius, etc.

The user space Open-iSCSI consists of a daemon process called iscsid,
and a management utility iscsiadm.



Authors:
--------
    open-iscsi@googlegroups.com

%prep
%setup -n %{name}-2.0-870-rc1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29
%patch30 -p1

%build
%{__make} OPTFLAGS="${RPM_OPT_FLAGS} -fno-strict-aliasing -DLOCK_DIR=\\\"/etc/iscsi\\\""

%install
make DESTDIR=${RPM_BUILD_ROOT} install
make DESTDIR=${RPM_BUILD_ROOT} install_initd_suse
install -D -m 755 %{S:11} ${RPM_BUILD_ROOT}/sbin/iscsi-gen-initiatorname
(cd ${RPM_BUILD_ROOT}/sbin; ln -sf /etc/init.d/open-iscsi rcopen-iscsi)
(cd ${RPM_BUILD_ROOT}/etc; ln -sf iscsi/iscsid.conf iscsid.conf)

%clean
[ "${RPM_BUILD_ROOT}" != "/" -a -d ${RPM_BUILD_ROOT} ] && rm -rf ${RPM_BUILD_ROOT}

%post
[ -x /sbin/mkinitrd_setup ] && mkinitrd_setup
%{fillup_and_insserv -y boot.open-iscsi}
if [ ! -f /etc/iscsi/initiatorname.iscsi ] ; then
    /sbin/iscsi-gen-initiatorname
fi

%postun
[ -x /sbin/mkinitrd_setup ] && mkinitrd_setup
%{insserv_cleanup}

%preun
%{stop_on_removal open-iscsi}

%files
%defattr(-,root,root)
%dir /etc/iscsi
%attr(0600,root,root) %config(noreplace) /etc/iscsi/iscsid.conf
%dir /etc/iscsi/ifaces
%config /etc/iscsi/ifaces/iface.example
/etc/iscsid.conf
%config /etc/init.d/open-iscsi
%config /etc/init.d/boot.open-iscsi
/sbin/*
%dir /lib/mkinitrd
%dir /lib/mkinitrd/scripts
/lib/mkinitrd/scripts/setup-iscsi.sh
/lib/mkinitrd/scripts/boot-iscsi.sh
/lib/mkinitrd/scripts/boot-killiscsi.sh
%doc COPYING README
%doc %{_mandir}/man8/*

%changelog
* Sun Jul  3 2011 jankit@novell.com
- Handle nulls from sysfs, for recent kernels.
  Sysfs in recent kernels returns "(null)" instead of "<NULL>",
  handle that. Such "(null)" strings from sysfs as mapped to
  NULL values.
  Lack of this check, caused a non-existant password to be read as
  "(null)" and treated as a valid and present password, and so,
  AuthMethod=CHAP was used for a relogin. (bnc #683249,656119)
* Fri Mar 12 2010 mmarek@suse.cz
- Do not hardcode the iscsi_ibft module in the iscsi mkinitrd
  script, the ibft script handles this correctly (bnc#528657).
* Tue Nov  3 2009 coolo@novell.com
- updated patches to apply with fuzz=0
* Sun Jun 21 2009 crrodriguez@suse.de
- build with fno-strict-aliasing
- do not use static libc, this does not work in reality, use
  of getaddrinfo(3) requires shared libraries at runtime
* Mon Jan 26 2009 ro@suse.de
- change fillup call from "-Y" to "-y" the boot script has
  been present in this package for long enough (SLES10-GA)
* Mon Dec  8 2008 hare@suse.de
- Remove trailing tilde from /etc/iscsi/ifaces.example (bnc#450870)
* Fri Dec  5 2008 hare@suse.de
- Fixup 'onboot' for loginall (bnc#449108)
- Remove unused 'dump_char' definition in log.c
- Load ibft module before reading /sys/firmware (bnc#450897)
* Tue Dec  2 2008 hare@suse.de
- iscsiadm -m fw crashes on ppc (bnc#449116)
* Thu Nov 20 2008 hare@suse.de
- Add cxgb3i support (bnc#433500, FATE#304154)
- No pid file from init scripts
* Thu Nov 13 2008 hare@suse.de
- Update iscsi-gen-initiatorname to work with newer kernels
  (bnc#443509)
* Wed Nov 12 2008 hare@suse.de
- Update SUSE init scripts to work with newer kernels
- Move mkinitrd scriptlets to git repository
- Fixes for root-on-iSCSI:
  * Update mkinitrd scripts to work with newer kernels (bnc#435215)
  * Allow 'onboot' for iscsiadm -L
  * Add option to not write a pid file
- Update login retry mechanism to work around the spanning-tree
  issue (bnc#433363)
* Wed Sep  3 2008 hare@suse.de
- Pull in fixes from upstream git repository
- Call mkinitrd_setup during %%post and %%postun (bnc#413709)
* Thu Aug 28 2008 cthiel@suse.de
- fix init script
* Thu Jul 24 2008 hare@suse.de
- Update to 2.0-870-rc1
  * Fix login redirection
  * Fix NOP timeout handling
  * Various small bugfixes
- Include mkinitrd scriptlets.
* Tue Apr 29 2008 hare@suse.de
- Pull in fixes from upstream git repository
* Mon Apr 21 2008 hare@suse.de
- Scan memory area for iBFT correctly (bnc#378837)
* Tue Apr 15 2008 hare@suse.de
- Synchronize with SLES10 SP2
* Thu Apr 10 2008 hare@suse.de
- Tear down device stack before logging out (bnc#378141)
* Fri Apr  4 2008 hare@suse.de
- Don't try to print invalid log messages (bnc#372719)
- Cleanup IPC identifiers upon error (bnc#372719)
- Print iBFT error messages to stderr (bnc#372725)
* Mon Mar 17 2008 hare@suse.de
- Don't fail init script if called twice with 'stop' (bnc#369300)
* Wed Mar 12 2008 hare@suse.de
- Add parameter '-i' to fwparam_ibft for mkinitrd (bnc#277106)
- Only logout from targets marked as 'automatic' (bnc#369767)
* Mon Mar 10 2008 hare@suse.de
- Synchronize with git repository
- Fixes to simplify build process
- Re-implement fwparam_ibft (bnc#367437)
* Wed Mar  5 2008 hare@suse.de
- Fixup '-op' to not overwrite other nodes on discovery
  (bnc#365259)
* Mon Feb 18 2008 hare@suse.de
- Fixup /etc/init.d/boot.open-iscsi to use correct syntax
  for iscsiadm (bnc#360674)
* Thu Feb  7 2008 hare@suse.de
- Add '-op' option to discovery to avoid overwriting
  of existing nodes (bnc#357197)
* Thu Dec  6 2007 hare@suse.de
- Update to official version 2.0-866
- Include latest git patches (FATE#303021)
- Start initiator after iSCSI target (FATE#302415)
* Fri Nov 30 2007 hare@suse.de
- Rediscover all targets to make sure the network
  is up (#307930, #251675)
- Fixup debug option to iscsiadm (#346504)
* Thu Nov 15 2007 hare@suse.de
- Do not overwrite existing node records when doing a
  discovery (#278172)
* Fri Oct 26 2007 bphilips@suse.de
- Scan BIOS memory in blocks to avoid crash on buggy
  BIOS (#293845)
- Don't unload modules on stop to avoid kernel oops (#328923)
* Thu Aug  2 2007 hare@suse.de
- Fix insecure privileges and credential verification (#280413)
* Mon Jul  9 2007 hare@suse.de
- update to svn r866
- include latest git patches
* Fri May 11 2007 hare@suse.de
- Correct target and initiator mixup for ppc (#273600)
- Print LUN correctly (#271292)
* Thu Apr 26 2007 hare@suse.de
- fwparam_ibft crashes with Broadcom chips (#267458)
* Wed Apr  4 2007 hare@suse.de
- update to official release 2.0-754
- update to svn r779
- Include changes from SLES10 SP1
* Fri Mar 30 2007 hare@suse.de
- Include fwparam_ibft program for OpenPROM (#226682)
* Wed Mar 28 2007 hare@suse.de
- Return status '6' when root on iSCSI is not enabled (#257979)
* Fri Mar 16 2007 hare@suse.de
- Fix typo in output of fwparam_ibft (#250445)
* Thu Mar  8 2007 hare@suse.de
- connect() to the daemon might fail on busy machines (#244649)
* Mon Mar  5 2007 hare@suse.de
- Add /usr/bin/iscsi-dbconvert to convert SLES10 GA
  databases to new format (#251298)
* Fri Feb 16 2007 hare@suse.de
- Fix iscsiadm to print session info correctly (#243203)
* Thu Feb  8 2007 hare@suse.de
- update to svn r768
  - Update iSNS support (#243203)
- Correct typo in /etc/init.d/boot.open-iscsi (#243203)
* Fri Feb  2 2007 hare@suse.de
- Umount all luns on shutdown (#223484)
* Wed Jan 31 2007 hare@suse.de
- Remove the start iSCSI after Xen hack (#231077)
- Fixup /etc/init.d/boot.open-iscsi script (#239819)
* Thu Jan 18 2007 hare@suse.de
- Fix compat mode to display the record id.
- Add /sbin/iscsi-gen-initiatorname to generate
  a default iSCSI initiatorname.
* Mon Jan 15 2007 hare@suse.de
-  Fixup %%post scripts.
* Mon Jan 15 2007 hare@suse.de
- Reference symlink to /etc/iscsid.conf in rpm.
* Fri Jan 12 2007 hare@suse.de
- update to official version 2.0-707
- update to svn r759
  - Include iBFT BIOS tool (FATE 301671)
- Implement compability mode for iscsiadm
* Fri Oct 20 2006 hare@suse.de
- Update to svn r713
- Use /dev/urandom instead of rand() (#180837)
- Fixup init script
* Fri Oct  6 2006 hare@suse.de
- Update to official version 2.0-707
* Fri Jul 28 2006 olh@suse.de
- remove unused boot.proc from boot.open-iscsi (#181972)
* Mon Jun 19 2006 hare@suse.de
- update to svn r606
  - Include local patches
  - Fix OCFS2 hangs (#185107, #180773)
* Thu Jun  1 2006 hare@suse.de
- Added new startmode 'onboot' for root on iSCSI
- Added new init script boot.open-iscsi startup
  iscsid as early as possible (#176804)
* Wed May 31 2006 hare@suse.de
- update to svn r595
  - Include local patches
  - Fix lockup on target restart for real (#176151)
* Mon May 22 2006 hare@suse.de
- update to svn r581
  - Fix lockup when target is restarted (#176151)
- Start open-iscsi after Xen (#177381)
* Fri May 19 2006 hare@suse.de
- update to svn r574
  - Fix machine hang during error recovery (#174166)
- Display chap secrets for yast (#149055)
* Tue May  2 2006 hare@suse.de
- update to svn r564
  (contains all local changes)
* Tue Apr 25 2006 wrwhitehead@novell.com
- Fix communication hang (#157463).
- The iscsi-tcp_data_ready callback needs to empty out the
  tcp receive queue rather than just rely on the callback to
  occur for every message in the receive queue.
* Fri Apr 21 2006 hare@suse.de
- update to svn r545
  Fixes a crash with Wasabi targets (#157463).
* Wed Mar 22 2006 hare@suse.de
- Add rcopen-iscsi link (#158230)
- Check for active records before deletion (#149935)
- Do not display error messages on startup if no
  records are found.
* Fri Mar 10 2006 hare@suse.de
- Update to svn r520 (contains all local changes)
- Add documentation for discovery types (#149936)
* Tue Feb 28 2006 hare@suse.de
- Fixed type of portal_group_tag (#153638)
* Tue Feb 21 2006 hare@suse.de
- Fixed open-iscsi startup script (#148982)
* Mon Feb 20 2006 hare@suse.de
- Update to svn r495
- Implement iSCSI boot support (FATE #140350)
* Thu Feb  9 2006 hare@suse.de
- Update to svn r488 to match kernel revision
  (#149412).
- Remove obsolete patches.
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Mon Jan 23 2006 hare@suse.de
- Update to svn r473
- Enhance start script
- Fix appearent login failures.
* Fri Jan 20 2006 hare@suse.de
- Update to svn r471
- Fix start script.
* Mon Jan 16 2006 hare@suse.de
- Add Provides/Obsoletes tag.
* Fri Jan 13 2006 hare@suse.de
- Rebasing package to open-iscsi-0.5-454
- Update to svn r457
* Mon Dec 19 2005 hare@suse.de
- Update to svn r446.
* Thu Nov  3 2005 hare@suse.de
- Update to svn r436.
* Thu Sep  8 2005 hare@suse.de
- Update to svn r408.
  (Added NOOP IN handling)
- Removed obsolete patches
* Mon Aug 22 2005 hare@suse.de
- Update to svn r401.
- Fixed package to install properly.
- Fixed init script
- Added iscsi-iname to generate iSCSI Initiatorname.
* Mon Aug  8 2005 hare@suse.de
- Update to svn r389.
* Thu Jul  7 2005 hare@suse.de
- Initial version 0.3rc6-369
